#!/bin/bash
rm -rf build
mkdir -p build/free/game
mkdir -p build/pro/game
cp -r index.html static Lib build/free/game/
cp -r index.html static Lib build/pro/game/


# Make sure each version is configured as free or pro

sed -i .bak "s/var isIBasketFree = .* ;/var isIBasketFree = true ;/" build/free/game/static/js/iBasketGameModel.js
rm build/free/game/static/js/iBasketGameModel.js.bak

sed -i .bak "s/var isIBasketFree = .* ;/var isIBasketFree = false ;/" build/pro/game/static/js/iBasketGameModel.js
rm build/pro/game/static/js/iBasketGameModel.js.bak

ISO_8601_date=`date +%Y-%m-%d_%H.%M.%S`

cd build/free/game
zip -r ../../../ibasket_free_$ISO_8601_date.zip *
cd ../../../build/pro/game
zip -r ../../../ibasket_pro_$ISO_8601_date.zip *
cd ../../../

rm -rf build
