
function createFont( image, desc, scale ) {

    scale= scale||1;

    var req = false;
    if(window.XMLHttpRequest && !(window.ActiveXObject)) {
        try {
            req = new XMLHttpRequest();
        } catch(e) {
            req = false;
        }
    } else if(window.ActiveXObject) {
        try {
            req = new ActiveXObject("Msxml2.XMLHTTP");
        } catch(e) {
            try {
                req = new ActiveXObject("Microsoft.XMLHTTP");
            } catch(e) {
                req = false;
            }
        }
    }

    if(req) {
        

        req.open("GET", desc, false);
        req.onreadystatechange  = function(e) {
            if( req.status != 200 )
                return;

            var text= e.currentTarget ? e.currentTarget.responseText : e.target.responseText;
            text= text.split("\n");

            return createFontFromData(image, text, scale);
        } ;
        req.send();
    }

    return null;
}


function createFontFromData(image, text, scale)
{
    scale= scale||1;
    var si= new CAAT.Foundation.SpriteImage().initialize(image,1,1);

    for(var i=0; i<text.length; i++ ) {
                if (0===text[i].indexOf("char ")) {
                    var str= text[i].substring(5);
                    var pairs= str.split(' ');
                    var obj= {
                        x: 0,
                        y: 0,
                        width: 0,
                        height: 0,
                        xadvance : 0,
                        xoffset : 0,
                        yoffset: 0
                    };

                    for( var j=0; j<pairs.length; j++ ) {
                        var pair= pairs[j];
                        var pairData= pair.split("=");
                        var key= pairData[0];
                        var value= pairData[1];
                        if (value.charAt(0)==='"' && value.charAt(value.length-1)==='"') {
                            value.substring(1,value.length-1);
                        }
                        obj[ key ]= value;
                    }

                    obj.x*= scale;
                    obj.y*= scale;
                    obj.width*= scale;
                    obj.height*= scale;
                    obj.xadvance*= scale;
                    obj.xoffset*= scale;
                    obj.yoffset*= scale;

                    si.addElement( String.fromCharCode( obj.id ), obj);
                }
            }

    // HACK HACK
    // pending: refactor when font object is available.
    si.fontScale= 1/scale;
    return si;
}

function createSpriteMap( director, image, map, scale ) {

    var req = false;
    if(window.XMLHttpRequest && !(window.ActiveXObject)) {
        try {
            req = new XMLHttpRequest();
        } catch(e) {
            req = false;
        }
    } else if(window.ActiveXObject) {
        try {
            req = new ActiveXObject("Msxml2.XMLHTTP");
        } catch(e) {
            try {
                req = new ActiveXObject("Microsoft.XMLHTTP");
            } catch(e) {
                req = false;
            }
        }
    }

    if(req) {
        req.open("GET", map, false);
        req.onreadystatechange =  function(e) {
            if( req.status != 200 )
                return ;

            var text= e.currentTarget ? e.currentTarget.responseText : e.target.responseText;
            var obj= JSON.parse(text);

            createSpriteMapFromData(director, image, obj, scale);
        } ;
        req.send();

    }

    return null;
}

function createSpriteMapFromData( director, image, obj, scale ) {


    for( var img in obj.frames ) {
        var imgData= obj.frames[img];

        var si_obj= {
            x: imgData.frame.x * scale,
            y: imgData.frame.y * scale,
            width: imgData.spriteSourceSize.w * scale,
            height: imgData.spriteSourceSize.h * scale,
            id: '0'
        };

        var si= new CAAT.Foundation.SpriteImage().initialize( image, 1, 1 );
        si.addElement(0,si_obj);
        director.addImage( img.substring(0,img.indexOf('.')), si );
    }
    return null;
}
