CAAT.Module({
    defines:"iBasket.Pause",
    extendsWith:function () {

        var W= 2048;
        var H= 1536;

        return {
            scene : null,
            root : null,

            buton_continue : null,
            buton_menu : null,
            buton_restart : null,

            initialize : function( director, font ) {
                this.scene= director.createScene();

                var scale= Math.min( director.width/W, director.height/H );

                background= new CAAT.Foundation.Actor().
                    setBackgroundImage( "score_background", false).
                    setSize(director.width, director.height).
                    setImageTransformation( CAAT.Foundation.SpriteImage.TR_FIXED_TO_SIZE );
                this.scene.addChild( background );

                this.root= new CAAT.Foundation.ActorContainer().
                    setSize(W,H).
                    setScaleAnchored(scale,scale,0,0).
                    setLayout(new CAAT.Foundation.UI.Layout.BoxLayout().
                        setAxis(CAAT.Foundation.UI.Layout.LayoutManager.AXIS.Y).
                        setVGap(100).
                        setVerticalAlignment(CAAT.Foundation.UI.Layout.LayoutManager.ALIGNMENT.CENTER).
                        setHorizontalAlignment(CAAT.Foundation.UI.Layout.LayoutManager.ALIGNMENT.CENTER));

                this.root.setLocation( (director.width-W*scale)/2, 0 );

                this.buton_continue= iBasket.Util.createButtonWithTextAndIcon(
                    new CAAT.Foundation.SpriteImage().initialize( director.getImage("score_botonpequeno"), 3, 1),
                    "continue",
                    director.getImage("pause_continue"),
                    font,
                    function() {
                        director.setScene(1);
                    }
                );

                this.buton_menu= iBasket.Util.createButtonWithTextAndIcon(
                    new CAAT.Foundation.SpriteImage().initialize( director.getImage("score_botonpequeno"), 3, 1),
                    "menu",
                    director.getImage("score_menu"),
                    font,
                    function() {
                        director.easeInOut(
                            0,
                            CAAT.Foundation.Scene.EASE_TRANSLATE,
                            CAAT.Foundation.Actor.ANCHOR_LEFT,
                            3,
                            CAAT.Foundation.Scene.EASE_TRANSLATE,
                            CAAT.Foundation.Actor.ANCHOR_RIGHT,
                            1000,
                            false,
                            new CAAT.Interpolator().createExponentialInOutInterpolator(3,false),
                            new CAAT.Interpolator().createExponentialInOutInterpolator(3,false) );
                    }
                );

                this.buton_restart= iBasket.Util.createButtonWithTextAndIcon(
                    new CAAT.Foundation.SpriteImage().initialize( director.getImage("score_botonpequeno"), 3, 1),
                    "restart",
                    director.getImage("score_playagain"),
                    font,
                    function() {
                        director.getValueForKey("GameModel").reset();
                        director.setScene(1);
                    }
                );

                this.root.addChild(this.buton_continue);
                this.root.addChild(this.buton_menu);
                this.root.addChild(this.buton_restart);

                this.scene.addChild( this.root );
            }
        }
    }
});