CAAT.Module({
    defines:"iBasket.Result",
    extendsWith:function () {

        var W= 2048;
        var H= 1536;

        return {
            scene : null,
            root : null,

            scoreActor : null,
            accuracyActor : null,
            shareActor : null,
            fbActor : null,

            bmenu : null,
            brate : null,
            bplayagain : null,
            shareActor : null,
            scoresActor : null,

            newRecord : null,

            loadingLayer : null,

            localScore : 0,

            initialize : function(director, font) {

                // get local score.
                var me= this;
                var russ= function(userID, score) {
                    me.localScore= score|0;
                    CocoonJS.SocialGaming.LocalStorage.onRequestUserScoreSucceed.removeEventListener(russ);
                };
                CocoonJS.SocialGaming.LocalStorage.onRequestUserScoreSucceed.addEventListener(russ);
                CocoonJS.SocialGaming.LocalStorage.requestUserScore();

                this.scene= director.createScene().setId("iBasket.ResultScene");

                // BUGBUG nasty hack. a rate observer event must be used instead of this.
                director.setValueForKey("iBasket.ResultScene",this);

                var scale= Math.min( director.width/W, director.height/H );

                this.scene.addChild( new CAAT.Foundation.Actor().
                    setBackgroundImage( director.getImage("score_background")).
                    setSize(director.width, director.height).
                    setImageTransformation( CAAT.Foundation.SpriteImage.TR_FIXED_TO_SIZE ) );


                this.root= new CAAT.Foundation.ActorContainer().
                    setSize(W,H).
                    setScaleAnchored(scale,scale,0,0).
                    setLayout(new CAAT.Foundation.UI.Layout.BoxLayout().
                        setAxis(CAAT.Foundation.UI.Layout.LayoutManager.AXIS.Y).
                        setVGap(35).
                        setVerticalAlignment(CAAT.Foundation.UI.Layout.LayoutManager.ALIGNMENT.CENTER).
                        setHorizontalAlignment(CAAT.Foundation.UI.Layout.LayoutManager.ALIGNMENT.CENTER));

                this.root.setLocation( (director.width-W*scale)/2, 0 );

                this.newRecord= new CAAT.Foundation.Actor().
                    setBackgroundImage("score_newrecord").
                    setPreventLayout(true).
                    addBehavior(
                        new CAAT.Behavior.ScaleBehavior().
                            setValues(1,1.3, 1,1.3).
                            setCycle(true).
                            setDelayTime(0,2500).
                            setPingPong()
                    ).
                    rescale();

                this.scoreActorC= new CAAT.Foundation.ActorContainer();

                this.scoreActor= new CAAT.Foundation.UI.TextActor().
                    setFont(font).
                    setText("POINTS: 0000").
                    setScaleAnchored(2,2,.5,.8);
                this.scoreActorC.addChild(this.scoreActor);
                this.scoreActorC.addChild(this.newRecord);
                this.root.addChild( this.scoreActorC );

                this.accuracyActor= new CAAT.Foundation.UI.TextActor().
                    setFont(font).
                    setText("ACCURACY: 00%").
                    setScale(1.5, 1.5);
                this.root.addChild( this.accuracyActor );

                this.createShare(director, font);


                this.scoresActor= iBasket.Util.createButtonWithTextAndIcon(
                    new CAAT.Foundation.SpriteImage(director.getImage("score_botongrande"),3,1 ),
                    "view scores",
                    director.getImage("score_score"),
                    font,
                    function() {
                        var fn= function(srv, me) {
                            me.loadingLayer.show();
                            srv.onLeaderboardViewFailed.addEventListenerOnce(function() {
                                me.loadingLayer.hide();
                            });
                            srv.onLeaderboardViewSucceed.addEventListenerOnce(function() {
                                me.loadingLayer.hide();
                            });
                            srv.showLeaderboardView();
                            me.socialSelection.setVisible(false);
                        }

                        iBasket.Util.setupSocialSelection(me.socialSelection, fn, me);

                    }
                );
                this.root.addChild( this.scoresActor );

                var me= this;
                this.scene.getIn= function() {
                    var gameModel= director.getValueForKey("GameModel");
                    var score= gameModel.getScore();
                    me.scoreActor.setText("POINTS: "+score);
                    me.scoreActorC.setSize( me.scoreActor.width, me.scoreActor.height );
                    me.accuracyActor.setText("ACCURACY: "+gameModel.getAccuracy()+"%");
                    me.root.invalidateLayout();

                    if ( me.localScore<score ) {
                        me.localScore= score;
                        me.newRecord.setVisible(true);
                        me.newRecord.setPosition(40 + me.scoreActorC.width + (me.scoreActorC.width*me.scoreActor.scaleX-me.scoreActorC.width)/2, 0);
                    } else {
                        me.newRecord.setVisible(false);
                    }

                    me.shareActor.setVisible( CocoonJS.SocialGaming.Facebook.isLoggedIn() );
                    me.scoresActor.setVisible( CocoonJS.SocialGaming.SocialGamingManager.isLoggedInAnySocialGamingService() );


                    director.getValueForKey("RatingPolicy").incrementCounter();
                    director.getValueForKey("InterstitialPolicy").incrementCounter();

                    me.removeAds.setVisible(iBasket.Prefs.ADS_ENABLED);

                    // show an interstitial. oh yeah!!!
                    if (iBasket.INTERSTITIAL && iBasket.Prefs.ADS_ENABLED) {
                        CocoonJS.Ad.showFullScreen();
                    }
                }

                this.createButtons( director, font );

                // loading layer
                this.loadingLayer= iBasket.Util.createLoadingLayer(director, "spinner", font);
                this.scene.addChild( this.loadingLayer);

                this.scene.addChild( this.root );

                this.createSocialSelection(director);


                var s= director.getValueForKey("WORLD_SCREEN_SCALE");
                //this.removeAds= new iBasket.Util.createButtonWithTextAndIcon(
                this.removeAds= new CAAT.Foundation.Actor().
                    setAsButton(
                        new CAAT.Foundation.SpriteImage().initialize( director.getImage("removeads"), 1, 2),
                        0,1,1,1,
                        function() {
                            iBasket.Util.buyAds(
                                function onPurchaseStarted( product ) {
                                    me.loadingLayer.show();
                                },
                                function onPurchaseFailed( products, productId, error) {
                                    me.loadingLayer.hide();
                                    alert("Purchase of Item '" + products[0].title + "' failed: " + error);
                                },
                                function onPurchaseCompleted(msg) {
                                    me.loadingLayer.hide();
                                    me.relayoutMenu();
                                    me.removeAds.setVisible(false);
                                    alert(msg);

                                });
                        }
                    ).
                    setLocation( 0,0).
                    setPreventLayout(true).
                    rescale();

                if ( navigator.isCocoonJS && iBasket.Prefs.ADS_ENABLED ) {
                    this.root.addChild( this.removeAds );
                }
            },

            createSocialSelection : function(director) {
                this.socialSelection= iBasket.Util.createSocialSelection(director);
                this.scene.addChild(this.socialSelection);
            },

            createShare : function(director, font) {
                var me= this;

                var c= new CAAT.Foundation.Actor().
                    setAsButton( new CAAT.Foundation.SpriteImage('share_fb', 1, 3), 0,1,2,0, function(button) {
                        CocoonJS.SocialGaming.Facebook.requestMessagePublicationWithDialog(
                            new CocoonJS.Social.Message(
                                "I just scored "+me.localScore+" points in iBasket.\n" + "I dare you to beat me.",
                                "http://storage.cocoonjsservice.ludei.com/resources/442b120b/res846421032503313421apple-retina-144.png",
                                "https://apps.facebook.com/ibasket/",
                                "iBasket",
                                "Ludei")
                        );
                    }).
                    rescale();

                this.shareActor= c;

                this.root.addChild(c);
            },

            createButtons : function( director, font ) {

                var me= this;

                this.bmenu= new iBasket.Util.createButtonWithTextAndIcon(
                    new CAAT.Foundation.SpriteImage().initialize( director.getImage("score_botonpequeno"), 3, 1),
                    "menu",
                    director.getImage("score_menu"),
                    font,
                    function() {
                        director.easeInOut(
                            0,
                            CAAT.Foundation.Scene.EASE_TRANSLATE,
                            CAAT.Foundation.Actor.ANCHOR_LEFT,
                            2,
                            CAAT.Foundation.Scene.EASE_TRANSLATE,
                            CAAT.Foundation.Actor.ANCHOR_RIGHT,
                            1000,
                            false,
                            new CAAT.Interpolator().createExponentialInOutInterpolator(3,false),
                            new CAAT.Interpolator().createExponentialInOutInterpolator(3,false) );
                    }
                );


                this.bplayagain= new iBasket.Util.createButtonWithTextAndIcon(
                    new CAAT.Foundation.SpriteImage().initialize( director.getImage("score_botonpequeno"), 3, 1),
                    "play again",
                    director.getImage("score_playagain"),
                    font,
                    function() {
                        director.getValueForKey("GameModel").reset();
                        director.easeInOut(
                            1,
                            CAAT.Foundation.Scene.EASE_TRANSLATE,
                            CAAT.Foundation.Actor.ANCHOR_BOTTOM,
                            2,
                            CAAT.Foundation.Scene.EASE_TRANSLATE,
                            CAAT.Foundation.Actor.ANCHOR_TOP,
                            1000,
                            false,
                            new CAAT.Interpolator().createExponentialInOutInterpolator(3,false),
                            new CAAT.Interpolator().createExponentialInOutInterpolator(3,false) );
                    }
                );

                if ( navigator.isCocoonJS ) {
                    this.brate= new iBasket.Util.createButtonWithTextAndIcon(
                        new CAAT.Foundation.SpriteImage().initialize( director.getImage("score_botonpequeno"), 3, 1),
                        "rate it",
                        director.getImage("score_rate"),
                        font,
                        function() {
                            me.rateThisApp();
                        }
                    );
                }

                var c= new CAAT.Foundation.ActorContainer().
                    setSize(W,this.bmenu.height).
                    setLayout(new CAAT.Foundation.UI.Layout.BoxLayout().
                        setAxis(CAAT.Foundation.UI.Layout.LayoutManager.AXIS.X).
                        setHGap(20).
                        setPadding(50,50,0,0).
                        setVerticalAlignment(CAAT.Foundation.UI.Layout.LayoutManager.ALIGNMENT.CENTER).
                        setHorizontalAlignment(CAAT.Foundation.UI.Layout.LayoutManager.ALIGNMENT.CENTER));

                c.addChild( this.bmenu );
                if (this.brate) c.addChild(this.brate);
                c.addChild(this.bplayagain);

                this.buttonsC= c;

                this.root.addChild(c);
            },

            rateThisApp : function() {

                this.buttonsC.removeChildAt(1);

                setTimeout( function() {
                    iBasket.Util.rateTheApp();
                }, 0 );
            }
        }
    }
});