var W=2048;
var H=1536;
var WORLD_RIGHT_BOUNDS= W;

CAAT.Module({
    defines:"iBasket.World",
    extendsWith:function () {

        var WORLD_SCALE=1

        return {

            director:null,
            scene:null,
            ballContainer:null,
            world:null, // box2dworld

            clientSocket:null,
            gameModel:null,

            eventCleanActor:null,
            eventYehaaActor:null,
            eventFireActor:null,

            gameChrono:null,

            backgroundActor : null,
            rootActor: null,
            ballContainer: null,
            scoreActor: null,
            countDownActor: null,
            sensorActors: null,
            multiplierActor : null,
            chronoActor : null,

            soundActor : null,
            musicActor : null,

            __init  : function() {
                this.sensorActors= [];
                return this;
            },

            initialize:function (director, font) {

                var me = this;
                this.gameModel = new iBasket.GameModel();

                director.setValueForKey("GameModel",this.gameModel);

                this.director = director;
                this.font = font;

                this.createiBasketScene(director);
                this.createAchievements(director,font);
                this.createWorld(director);
                this.createWorldBounds(director);
                this.createBasketBodies(director);
                this.createBasketSensors(director);

                this.rootActor.addChild(
                    new CAAT.Foundation.Actor().
                        setBackgroundImage(director.getImage("billboard")).
                        setLocation(1175,340).
                        setId("billboard").
                        rescale() );


                this.createBallContainer(director);
                this.createImpostors(director);
                this.createContactListener(director);
                this.createScoreActor(director);
                this.createFireActor(director);
                this.createCleanActor(director);
                this.createMultiplierActor(director);
                this.createYehaaActor(director);
                this.createChronoActor(director);
                this.createCountDownActor(director, font);
                this.createTimeUp(director);

                this.createSoundControls(director);


                if ( iBasket.Prefs.DEBUG ) {
                    CAAT.enableBox2DDebug( true, director, this.world );
                }

                var im= new CAAT.Foundation.SpriteImage(director.getImage("boton-pause"),1,3);
                var boton=
                    new CAAT.Foundation.Actor().
                        setAsButton(im,0,1,2,0,function() {
                             if (me.gameModel.status === iBasket.GameModel.STATUS.COUNTDOWN || me.gameModel.status === iBasket.GameModel.STATUS.PLAY)
                             {
                                director.setScene(3);
                             }
                        }).
                        rescaleToScreen();

                this.backgroundActor.addChild(boton.setLocation( director.width-boton.width-5, 5));
                this.scene.enableInputList(1);
                this.scene.addActorToInputList(boton, 0);

                if ( iBasket.Prefs.DEBUG ) {
                    this.scene.onRenderEnd =  function()    {
                        director.ctx.save();
                        var s= director.getValueForKey("WORLD_SCREEN_SCALE");
                        director.ctx.setTransform(s,0,0,s,0,0);
                        me.world.DrawDebugData();
                        director.ctx.restore();
                    };
                }


                this.gameModel
                    .addListener( function gameEvent(event, data) {
                        if (event === 'start') {            // game start
                            // setup a timer which upon expiration tells the server
                            me.gameModel.nextBall();
                        } else if (event === 'newball') {    // get a new ball
                            me.ballContainer.newBall(data);
                        } else if (event === 'canasta') {   // canasta en el juego
                            if (data) {
                                me.showClean();
                            }
                        } else if (event === 'status' ) {
                            me.gameStatusChanged(data);
                        }
                    }
                );

            },

            createSoundControls : function(director) {
                var c= iBasket.Util.createSoundControls(director,"sound").setId("soundControlContainer");
                c.setLocation( 20, 20).rescale();
                c.childrenList[1].x= c.childrenList[0].width+40;

                 this.rootActor.addChild(c);

                 this.musicActor= c.getMusicActor().setScaleAnchored(1.3,1.3,0,0);
                 this.soundActor= c.getAudioActor().setScaleAnchored(1.3,1.3,0,0);
            },

            createAchievements : function( director, font ) {
                this.backgroundActor.addChild(new iBasket.AchievementActor(director, font).setId("Achievements"));
            },

            gameStatusChanged : function( status ) {
                var me= this;

                if ( status===iBasket.GameModel.STATUS.COUNTDOWN ) {
                    this.reset();
                    this.ballContainer.canPlay(false);
                    this.countDownActor.setVisible(true);
                    this.setupCountDown();
                } else if ( status===iBasket.GameModel.STATUS.PLAY ) {
                    this.ballContainer.canPlay(true);
                    this.countDownActor.setVisible(false);
                } else if ( status===iBasket.GameModel.STATUS.WAITFORBALLS ) {
                    this.ballContainer.canPlay(false);
                    this.showTimeUp();
                    this.director.audioPlay("snd_airhorn");

                    /*
                    el evento de continuar con show results sale cuando todas las bolas del model box2d
                    han expirado.
                    si no hay ninguna bola en el mundo , pasamos a mostrar resultados directamente.
                     */
                    if ( !this.gameModel.getNumPlayingBalls() ) {
                        this.gameModel.setStatus(iBasket.GameModel.STATUS.SHOWRESULTS);
                    }
                } else if ( status===iBasket.GameModel.STATUS.SHOWRESULTS ) {

                    this.scene.createTimer( this.scene.time, 2000, function() {
                        me.director.easeInOut(
                            2,
                            CAAT.Foundation.Scene.EASE_TRANSLATE,
                            CAAT.Foundation.Actor.ANCHOR_BOTTOM,
                            1,
                            CAAT.Foundation.Scene.EASE_TRANSLATE,
                            CAAT.Foundation.Actor.ANCHOR_TOP,
                            1000,
                            false,
                            new CAAT.Interpolator().createExponentialInOutInterpolator(3,false),
                            new CAAT.Interpolator().createExponentialInOutInterpolator(3,false) );
                    });
                }
            },

            setupCountDown : function() {
                this.countDownActor.emptyBehaviorList();
                this.countDownActor.setSpriteIndex(2);
                this.countDownActor.setAlpha(0);


                var anim= [3,0,1,2];
                var me= this;
                var count=4;

                setTimeout(function(){me.director.audioPlay("snd_pip");},1000); 

                this.countDownActor.addBehavior(
                    new CAAT.Behavior.ContainerBehavior().
                        setId(666).
                        setDelayTime(1000,1000).
                        addBehavior(
                            new CAAT.Behavior.ScaleBehavior().
                                setValues(2,0.01, 2,0.01).
                                setDelayTime(0,1000).
                                setId(100)
                        ).
                        addBehavior(
                            new CAAT.Behavior.AlphaBehavior().
                                setValues(1,0).
                                setDelayTime(0,1000).
                                setId(101)
                        ).
                        addListener( {

                            behaviorExpired : function(behavior, time, actor) {
                                count--;
                                if ( count ) {
                                    behavior.setDelayTime(0,1000);
                                    actor.setSpriteIndex(anim[count-1]);
                                    if ( count===1 ) {
                                        behavior.getBehaviorById(100).setValues(1,1,1,1);
                                        me.director.audioPlay("snd_start");
                                    } 
                                    else {
                                        me.director.audioPlay("snd_pip");
                                    }

    
                                } else {
                                    me.gameModel.requestStartGame(me.scene);
                                }
                            }
                        } ) );

            },

            createCountDownActor : function(director, font) {
                var cd= new CAAT.Foundation.Actor().
                    setBackgroundImage(new CAAT.Foundation.SpriteImage(director.getImage("countdown"),2,2)).
                    setScale(2,2).
                    rescaleToScreen().
                    setVisible(false).
                    enableEvents(false).
                    setId("countdown");
                this.backgroundActor.addChild(cd);
                cd.centerAt( director.width/2, director.height/2 );
                this.countDownActor= cd;
            },

            reset : function() {
//                this.gameModel.reset();
                this.ballContainer.reset();
                this.scoreActor.reset();
                this.chronoActor.reset();
                this.multiplierActor.reset();
                this.eventYehaaActor.visible= false;
                this.eventFireActor.visible= false;
                this.countDownActor.setSpriteIndex(2);
                this.hideTimeUp();
            },

            createTimeUp : function(director) {
                this.timeUp= new CAAT.Foundation.ActorContainer().
                    setSize(director.width,director.height).
                    setFillStyle('#000').
                    enableEvents(false).
                    setVisible(false).
                    setId("timeupLayer").
                    addBehavior(
                        new CAAT.Behavior.AlphaBehavior().
                            setValues(0,.75).
                            setFrameTime(0,0).
                            setId(100)
                    );

                var timeup= new CAAT.Foundation.Actor().
                    setBackgroundImage( director.getImage("timeup")).
                    rescaleToScreen().
                    setId("timeup").
                    addBehavior(
                        new CAAT.Behavior.AlphaBehavior().
                            setValues(0,1).
                            setFrameTime(0,0).
                            setId(100)
                    );

                timeup.centerAt( director.width/2, director.height/2 );
                this.timeUp.addChild( timeup );
                this.backgroundActor.addChild( this.timeUp );

            },

            showTimeUp : function() {
                this.timeUp.parent.setZOrder(this.timeUp, Number.MAX_VALUE);
                this.timeUp.parent.enableEvents(true);
                this.timeUp.setVisible(true);
                this.timeUp.enableEvents(true);
                this.timeUp.getBehavior(100).setDelayTime(0,1000);
                this.timeUp.findActorById("timeup").getBehavior(100).setDelayTime(0,1000);
            },

            hideTimeUp : function() {
                this.timeUp.parent.enableEvents(false);
                this.timeUp.setVisible(false);
                this.timeUp.enableEvents(false);
            },

            createiBasketScene:function (director) {
                CAAT.PMR= W/iBasket.Prefs.CANCHA_SIZE;
                var me = this;

                this.scene = director.createScene();

                this.scene.activated= function() {
                    if (iBasket.Prefs.ADS_ENABLED) {
                        CocoonJS.Ad.showBanner();
                    }
                };

                this.scene.getIn = function () {

                    CAAT.PMR= W/iBasket.Prefs.CANCHA_SIZE;

                    iBasket.Prefs.FINGER_OFFSET_X= (!!('ontouchstart' in window) || !!('onmsgesturechange' in window)) ? iBasket.Prefs.FINGER_OFFSET_X_M*CAAT.PMR : 0;
                    iBasket.Prefs.FINGER_OFFSET_Y= (!!('ontouchstart' in window) || !!('onmsgesturechange' in window)) ? iBasket.Prefs.FINGER_OFFSET_Y_M*CAAT.PMR : 0;

                    me.musicActor.setSpriteIndex( director.isMusicEnabled() ? 0 : 1 );
                    me.soundActor.setSpriteIndex( director.isSoundEffectsEnabled() ? 2 : 3 );
                };

                this.scene.timeLeftToSim = 0 ;

                if (iBasket.Prefs.FIXED_TIME_STEP)  {
                    this.scene.onRenderStart = function () {
                
                        // Add last frame's time to the amount of time we must simulate
                        this.timeLeftToSim += CAAT.REQUEST_ANIMATION_FRAME_TIME/1000 ;

                        // Simulate at most 100 ms
                        if( this.timeLeftToSim > 0.10 )
                            this.timeLeftToSim = 0.10

                        // Step several times until physics time catches up with real time
                        do
                        {
                            me.world.Step(1.0 / 60, iBasket.Prefs.VELOCITY_ITERATIONS, iBasket.Prefs.POSITION_ITERATIONS);
                            this.timeLeftToSim -= 1.0/60;
                        } while( this.timeLeftToSim >= (1.0 / 60) );
                        
                        if (this.timeLeftToSim < 0)
                            this.timeLeftToSim = 0;

                        me.world.ClearForces();
                    };
                }
                else {
                    
                    this.scene.onRenderStart = function () 
                    {
                        var frameTime = CAAT.REQUEST_ANIMATION_FRAME_TIME/1000;
                        if (frameTime <= 1/60) {
                            me.world.Step(1.0 / 60, iBasket.Prefs.VELOCITY_ITERATIONS, iBasket.Prefs.POSITION_ITERATIONS);
                        }
                        else if (frameTime <= 1/45) {
                            me.world.Step(Math.min(frameTime, 1/45), iBasket.Prefs.VELOCITY_ITERATIONS, iBasket.Prefs.POSITION_ITERATIONS);
                        }
                        else {
                            var midStep = Math.min(frameTime * 0.5, 1/45);
                            me.world.Step(midStep, iBasket.Prefs.VELOCITY_ITERATIONS, iBasket.Prefs.POSITION_ITERATIONS);
                            me.world.ClearForces();
                            me.world.Step(midStep, iBasket.Prefs.VELOCITY_ITERATIONS, iBasket.Prefs.POSITION_ITERATIONS);
                        }
                        me.world.ClearForces();
                    };

                }

                

                var scale= Math.min( director.width/W, director.height/H );
                var background=
                    new CAAT.Foundation.ActorContainer().
                        setBackgroundImage(director.getImage('background'), true).
//                        setSize(W,H).
                        setScaleAnchored(scale,scale,0,0).
                        rescale().
                        setId("rootActor");
                        //setImageTransformation(CAAT.Foundation.SpriteImage.TR_FIXED_TO_SIZE);

                /**
                 * posicionar el bound derecho del mundo box2d al final de pantalla, y no ancho del actor.
                 */
                if ( director.width<W*scale ) {
                    WORLD_RIGHT_BOUNDS= director.width/scale;
                }

                this.backgroundActor= new CAAT.Foundation.ActorContainer().
                    setBounds(0,0,director.width,director.height).
                    enableEvents(false).
                    setId("backgroundActor");
                this.scene.addChild(background);
                this.scene.addChild(this.backgroundActor);
                WORLD_SCALE= scale;
                this.rootActor= background;

            },

            createWorld:function (director) {
                CAAT.PMR= W/iBasket.Prefs.CANCHA_SIZE;
                var gravity = new Box2D.Common.Math.b2Vec2(0, iBasket.Prefs.GRAVITY);
                var doSleep = true;
                this.world = new Box2D.Dynamics.b2World(gravity, doSleep);
                this.world.SetContinuousPhysics(true);
            },

            createWorldBounds:function (director) {

                var BOUNDS_DENSITY = 1.2;
                var BOUNDS_FRICTION = .9;
                var BOUNDS_RESTITUTION = .66;

                var ims= director.getValueForKey("IMS");
                var sc= CAAT.currentDirector.getValueForKey("WORLD_SCREEN_SCALE");

                var dx0 = 0;
                var dy0 = -170;
                var dx1 = director.width/sc;
                var dy1 = H - iBasket.Prefs.GROUND_POS;

                var i;

                var bounds = [
                    dx0, dy0,
                    dx1, dy0,
                    dx1, dy1,
                    dx0, dy1,
                    dx0, dy0
                ];

                for (i = 0; i < 3; i+=2) {
                    var actor0 = new CAAT.Foundation.Box2D.B2DPolygonBody().createBody(
                        this.world,
                        {
                            bodyType:Box2D.Dynamics.b2Body.b2_staticBody,
                            density:BOUNDS_DENSITY,
                            friction:BOUNDS_FRICTION,
                            restitution:BOUNDS_RESTITUTION,
                            polygonType:CAAT.Foundation.Box2D.B2DPolygonBody.TYPE.EDGE,
                            bodyDef:[
                                {x:bounds[i * 2  ], y:bounds[i * 2 + 1] },
                                {x:bounds[i * 2 + 2], y:bounds[i * 2 + 3] }
                            ],
                            userData:new iBasket.UserData(iBasket.BodyCollisionTypes.GROUND)
                        });
                    if (iBasket.Prefs.DEBUG) {
                        this.sensorActors.push(actor0);
                    }

                }
            },

            createBasketBodies:function (director) {

                var i, j;

                // cuerpo de colision vertical de la canasta. corresponde a la mitad del tablero
                var actor0 = new CAAT.Foundation.Box2D.B2DPolygonBody().createBody(
                    this.world,
                    {
                        bodyType:Box2D.Dynamics.b2Body.b2_staticBody,
                        density:iBasket.Prefs.TableroInfo.TABLERO_DENSITY,
                        friction:iBasket.Prefs.TableroInfo.TABLERO_FRICTION,
                        restitution:iBasket.Prefs.TableroInfo.TABLERO_RESTITUTION,
                        polygonType:CAAT.Foundation.Box2D.B2DPolygonBody.TYPE.EDGE,
                        bodyDef:[
                            {
                                x:iBasket.Prefs.TableroInfo.JOINT_X,
                                y:iBasket.Prefs.TableroInfo.JOINT_Y - iBasket.Prefs.TableroInfo.TABLERO_H
                            },
                            {
                                x:iBasket.Prefs.TableroInfo.JOINT_X,
                                y:iBasket.Prefs.TableroInfo.JOINT_Y
                            }
                        ],
                        userData:new iBasket.UserData(iBasket.BodyCollisionTypes.TABLERO)
                    }
                );
                if (iBasket.Prefs.DEBUG) {
                    this.sensorActors.push(actor0);
                }


                // cuerpo de colision 'molesto'
                // el cuerpo esta inclinado levemente para evitar que la pelota se quede enganchada en el
                // aro sin moverse.
                var molesto = new CAAT.Foundation.Box2D.B2DPolygonBody().createBody(
                    this.world,
                    {
                        bodyType:Box2D.Dynamics.b2Body.b2_staticBody,
                        density:iBasket.Prefs.TableroInfo.TABLERO_DENSITY,
                        friction:iBasket.Prefs.TableroInfo.TABLERO_FRICTION,
                        restitution:iBasket.Prefs.TableroInfo.TABLERO_RESTITUTION,
                        polygonType:CAAT.Foundation.Box2D.B2DPolygonBody.TYPE.EDGE,
                        bodyDef:[
                            {
                                x:iBasket.Prefs.TableroInfo.JOINT_X,
                                y:iBasket.Prefs.TableroInfo.JOINT_Y - 1
                            },
                            {
                                x:iBasket.Prefs.TableroInfo.JOINT_X + iBasket.Prefs.TableroInfo.MINITAB_SIZE,
                                y:iBasket.Prefs.TableroInfo.JOINT_Y + 1
                            }
                        ],
                        userData:new iBasket.UserData(iBasket.BodyCollisionTypes.TABLERO)
                    }
                );
                if (iBasket.Prefs.DEBUG) {
                    this.sensorActors.push(molesto);
                }


                // cuerpo de colision de la punta del aro.
                var aro = new CAAT.Foundation.Box2D.B2DCircularBody().createBody(
                    this.world,
                    {
                        x:iBasket.Prefs.TableroInfo.JOINT_X + iBasket.Prefs.TableroInfo.BOLA_MAX_W,
                        y:iBasket.Prefs.TableroInfo.JOINT_Y + 8,
                        radius:iBasket.Prefs.TableroInfo.HOOP_RADIUS,
                        bodyType:Box2D.Dynamics.b2Body.b2_staticBody,
                        density:iBasket.Prefs.TableroInfo.HOOP_DENSITY,
                        friction:iBasket.Prefs.TableroInfo.HOOP_FRICTION,
                        restitution:iBasket.Prefs.TableroInfo.HOOP_RESTITUTION,
                        image:null,
                        userData:new iBasket.UserData(iBasket.BodyCollisionTypes.TABLERO)
                    });
                if (iBasket.Prefs.DEBUG) {
                    this.sensorActors.push(aro);
                }

                /////// Net
                /*
                 creamos una malla de cuerpos.
                 */

                var netData = [];
                var xnet = iBasket.Prefs.TableroInfo.JOINT_X + iBasket.Prefs.TableroInfo.MINITAB_SIZE;
                var wnet = iBasket.Prefs.TableroInfo.BOLA_MAX_W - iBasket.Prefs.TableroInfo.MINITAB_SIZE - iBasket.Prefs.TableroInfo.HOOP_RADIUS;

                for (i = 0; i < iBasket.Prefs.NetInfo.ROWS; i++) {

                    netData.push([]);
                    var bt = i == 0 ? Box2D.Dynamics.b2Body.b2_kinematicBody : Box2D.Dynamics.b2Body.b2_dynamicBody;

                    for (j = 0; j < iBasket.Prefs.NetInfo.COLUMNS; j++) {
                        var netc = new CAAT.Foundation.Box2D.B2DCircularBody().createBody(
                            this.world,
                            {
                                x:xnet +
                                    iBasket.Prefs.NetInfo.OFFSET / 2 * i +
                                    (wnet - iBasket.Prefs.NetInfo.OFFSET * i) /
                                        (iBasket.Prefs.NetInfo.COLUMNS - 1) * j,
                                y:iBasket.Prefs.TableroInfo.JOINT_Y + 2 +
                                    i * iBasket.Prefs.NetInfo.VERTICAL_OFFSET,
                                radius:(j != 0 && j != iBasket.Prefs.NetInfo.COLUMNS - 1) ?
                                    iBasket.Prefs.NetInfo.BODY_RADIUS :
                                    iBasket.Prefs.NetInfo.BODY_RADIUS * 3,
                                bodyType:bt,
                                density:iBasket.Prefs.NetInfo.NET_DENSITY,
                                friction:iBasket.Prefs.NetInfo.NET_FRICTION,
                                restitution:iBasket.Prefs.NetInfo.NET_RESTITUTION,
                                image:null,
                                userData:i == 0 ?
                                    new iBasket.UserData(iBasket.BodyCollisionTypes.NET_SENSOR) :
                                    (j == 0 || j == iBasket.Prefs.NetInfo.COLUMNS - 1 ?
                                        new iBasket.UserData(iBasket.BodyCollisionTypes.NET_SOUND) :
                                        new iBasket.UserData(iBasket.BodyCollisionTypes.NET)),
                                isSensor:i == 0 || (j != 0 && j != iBasket.Prefs.NetInfo.COLUMNS - 1)
                            });
                        netData[i].push(netc);
                        if (iBasket.Prefs.DEBUG) {
                            this.sensorActors.push(netc);
                        }
                    }
                }

                var disJDef = new Box2D.Dynamics.Joints.b2DistanceJointDef();
                var me = this;

                function makeJoint(actorA, actorB, userData) {
                    disJDef.bodyA = actorA.worldBody;
                    disJDef.bodyB = actorB.worldBody;
                    disJDef.dampingRatio = iBasket.Prefs.NetInfo.NET_DAMPING;
                    disJDef.frequencyHz = iBasket.Prefs.NetInfo.NET_FREQUENCY;
                    disJDef.collideConnected = iBasket.Prefs.NetInfo.NET_SELF_COLLIDE;
                    var pa, pb;
                    pa = actorA.getCenter();
                    pb = actorB.getCenter();
                    disJDef.length = Math.sqrt((pa.x - pb.x) * (pa.x - pb.x) + (pa.y - pb.y) * (pa.y - pb.y));
                    disJDef.localAnchorA = actorA.getDistanceJointLocalAnchor();
                    disJDef.localAnchorB = actorB.getDistanceJointLocalAnchor();
                    disJDef.userData = userData;
                    me.world.CreateJoint(disJDef);
                }

                var cols = netData[0].length;
                for (i = 0; i < iBasket.Prefs.NetInfo.ROWS - 1; i++) {
                    for (j = 0; j < cols; j++) {
                        // verticales
//                    if ( j==0 || j==cols-1 ) {
                        makeJoint(netData[i][j], netData[i + 1][j], (j != 0 && j != cols - 1) ? {nodraw:true} : null);
//                    }

                        if (j < cols - 1) {
                            makeJoint(netData[i][j], netData[i + 1][j + 1], null);
                            makeJoint(netData[i][j + 1], netData[i + 1][j], null);
                        }
                    }
                }
            },

            createBasketSensors:function (director) {
                for (var i = 0; i < iBasket.Prefs.TableroInfo.POINTS_SENSORS; i++) {
                    var actor0 = new CAAT.Foundation.Box2D.B2DPolygonBody().createBody(
                        this.world,
                        {
                            bodyType:Box2D.Dynamics.b2Body.b2_staticBody,
                            density:iBasket.Prefs.TableroInfo.TABLERO_DENSITY,
                            friction:iBasket.Prefs.TableroInfo.TABLERO_FRICTION,
                            restitution:iBasket.Prefs.TableroInfo.TABLERO_RESTITUTION,
                            polygonType:CAAT.Foundation.Box2D.B2DPolygonBody.TYPE.EDGE,
                            bodyDef:[
                                {
                                    x:iBasket.Prefs.TableroInfo.JOINT_X +
                                        iBasket.Prefs.TableroInfo.MINITAB_SIZE,
                                    y:iBasket.Prefs.TableroInfo.JOINT_Y +
                                        i * (iBasket.Prefs.NetInfo.ROWS *
                                            iBasket.Prefs.TableroInfo.SENSOR_OFFSET) /
                                            (iBasket.Prefs.TableroInfo.POINTS_SENSORS + 1)
                                },
                                {
                                    x:iBasket.Prefs.TableroInfo.JOINT_X +
                                        iBasket.Prefs.TableroInfo.BOLA_MAX_W,
                                    y:iBasket.Prefs.TableroInfo.JOINT_Y +
                                        i * (iBasket.Prefs.NetInfo.ROWS *
                                            iBasket.Prefs.TableroInfo.SENSOR_OFFSET) /
                                            (iBasket.Prefs.TableroInfo.POINTS_SENSORS + 1)
                                }
                            ],
                            userData:new iBasket.BasketSensorUserData('basket' + i),
                            isSensor:true
                        }
                    );
                    if (iBasket.Prefs.DEBUG) {
                        this.sensorActors.push(actor0);
                    }

                }

                var actor1 = new CAAT.Foundation.Box2D.B2DPolygonBody().createBody(
                    this.world,
                    {
                        bodyType:Box2D.Dynamics.b2Body.b2_staticBody,
                        density:iBasket.Prefs.TableroInfo.TABLERO_DENSITY,
                        friction:iBasket.Prefs.TableroInfo.TABLERO_FRICTION,
                        restitution:iBasket.Prefs.TableroInfo.TABLERO_RESTITUTION,
                        polygonType:CAAT.Foundation.Box2D.B2DPolygonBody.TYPE.EDGE,
                        bodyDef:[
                            {
                                x:1 + iBasket.Prefs.TableroInfo.JOINT_X + iBasket.Prefs.TableroInfo.BOLA_MAX_W,
                                y:iBasket.Prefs.TableroInfo.JOINT_Y + iBasket.Prefs.TableroInfo.SENSOR_OFFSET
                            },
                            {
                                x:1 + iBasket.Prefs.TableroInfo.JOINT_X + iBasket.Prefs.TableroInfo.BOLA_MAX_W,
                                y:H
                            }
                        ],
                        userData:new iBasket.BasketSensorUserData('prohibido'),
                        isSensor:true
                    }
                );
                if (iBasket.Prefs.DEBUG) {
                    this.sensorActors.push(actor1);
                }


                /**
                 * The horizontal sensor is at the base of the basket
                 */
                var actor2 = new CAAT.Foundation.Box2D.B2DPolygonBody().createBody(
                    this.world,
                    {
                        bodyType:Box2D.Dynamics.b2Body.b2_staticBody,
                        density:iBasket.Prefs.TableroInfo.TABLERO_DENSITY,
                        friction:iBasket.Prefs.TableroInfo.TABLERO_FRICTION,
                        restitution:iBasket.Prefs.TableroInfo.TABLERO_RESTITUTION,
                        polygonType:CAAT.Foundation.Box2D.B2DPolygonBody.TYPE.EDGE,
                        bodyDef:[
                            {
                                x:iBasket.Prefs.TableroInfo.JOINT_X ,
                                y:iBasket.Prefs.TableroInfo.JOINT_Y +
                                    iBasket.Prefs.NetInfo.ROWS * iBasket.Prefs.NetInfo.VERTICAL_OFFSET
                            },
                            {
                                x:iBasket.Prefs.TableroInfo.JOINT_X + iBasket.Prefs.TableroInfo.BOLA_MAX_W, // director.width,
                                y:iBasket.Prefs.TableroInfo.JOINT_Y + iBasket.Prefs.NetInfo.ROWS * iBasket.Prefs.NetInfo.VERTICAL_OFFSET
                            }
                        ],
                        userData:new iBasket.BasketSensorUserData('horizontal'),
                        isSensor:true
                    }
                );
                if (iBasket.Prefs.DEBUG) {
                    this.sensorActors.push(actor2);
                }

            },

            createImpostors:function (director) {

                var ti = director.getImage('tablero_impostor');
                var tia=
                    new CAAT.Foundation.Actor().
                        setBackgroundImage(ti).
                        enableEvents(false).
                        rescale().
                        setId("tableroImpostor");
                tia.setLocation(iBasket.Prefs.TableroInfo.JOINT_X - tia.width + 6, 486);

                this.rootActor.addChild( tia );

                var til=
                    new CAAT.Foundation.Actor().
                        setBackgroundImage(director.getImage('aro_impostor')).
                        setLocation(iBasket.Prefs.TableroInfo.JOINT_X, iBasket.Prefs.TableroInfo.JOINT_Y).
                        enableEvents(false).
                        rescale().
                        setId("aroImpostor");

                this.rootActor.addChild(til);

            },

            createBallContainer:function (director) {
                this.ballContainer = new iBasket.BallContainer(director, this.gameModel, this.world).
                    setBounds(0, 0, W,H).
                    setId("ballContainer");
                this.rootActor.addChild(this.ballContainer);

                this.rootActor.addChild(
                    new iBasket.NetDrawer(this.world).
                        setBounds(0, 0, W,H).
                        setId("netDrawer") );

                this.gameModel.addListener(
                    this.ballContainer.contextEvent.bind(this.ballContainer)
                )
            },

            createContactListener:function (director) {
                this.world.SetContactListener(
                    this.gameModel.createContactListener(director, this.world));
            },

            createScoreActor:function (director) {
                var actorScore = new iBasket.ScoreActor(this.font, director.getImage("bgscore")).
                    enableEvents(false).
                    setLocation(1200, 10).
                    setId("score");
                this.rootActor.addChild(actorScore);
                this.scoreActor= actorScore;

                this.gameModel.addListener(actorScore.gameEvent.bind(actorScore));
            },

            createMultiplierActor:function (director) {
                var actorMultiplier = new iBasket.MultiplierActor().
                    initialize(this.scene).
                    setBackgroundImage(new CAAT.Foundation.SpriteImage("pet",1,3)).
                    setVisible(false).
                    enableEvents(false).
                    rescale().
                    setId("multiplier");

                actorMultiplier.setLocation( 20, H-100-actorMultiplier.height );

                this.rootActor.addChild(actorMultiplier);
                this.multiplierActor= actorMultiplier;

                this.gameModel.addListener(actorMultiplier.contextEvent.bind(actorMultiplier));
            },

            createCleanActor:function (director) {
                this.eventCleanActor = new CAAT.Actor().
                    setBackgroundImage(new CAAT.SpriteImage().initialize(director.getImage('event_clean'),6,3)).
                    enableEvents(false).
                    setPositionAnchor(.5,1).
                    setLocation(564, 695).
                    setAnimationImageIndex([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16]).
                    setChangeFPS(100).
                    setAnimationEndCallback( function(si) {
                        si.ownerActor.setVisible(false);
                    }).
                    setVisible(false).
                    rescale().
                    setId("clean");
                this.rootActor.addChild(this.eventCleanActor);
            },

            createFireActor : function(director) {
                var me= this;

                this.eventFireActor= new CAAT.Actor().
                    setBackgroundImage(new CAAT.SpriteImage().initialize(director.getImage('fire'),1,7)).
                    enableEvents(false).
                    setPositionAnchor(.5,1).
                    setLocation(564, 685).
                    setAnimationImageIndex([0,1,2,3,4,5,6]).
                    setChangeFPS(100).
                    setAnimationEndCallback( function(si) {
                        si.ownerActor.setVisible(false);
                    }).
                    setVisible(false).
                    rescale().
                    setId("fire");

                this.gameModel.addListener(function (event, data) {
                    if (event === 'fire') {
                        me.showFire();
                        me.director.audioPlay('snd_fire');
                    }
                });

                this.rootActor.addChild(this.eventFireActor);

            },

            showFire : function() {
                this.eventFireActor.resetAnimationTime().setVisible(true);
            },

            showShake:function (actor, time, numShakes, minS, maxS) {
                actor.emptyBehaviorList();
                for (var i = 0; i < 5; i++) {
                    actor.addBehavior(
                        new CAAT.ScaleBehavior().
                            setValues(minS, maxS, minS, maxS).
                            setDelayTime( (time / numShakes) * i, time / numShakes).
                            setInterpolator(
                            new CAAT.Interpolator().createLinearInterpolator(true, false)
                        )
                    );
                }

                actor.setFrameTime(this.scene.time, time + 50);
                actor.setVisible(true);
            },

            showClean:function () {
                this.eventCleanActor.resetAnimationTime().setVisible(true);
            },

            createYehaaActor:function (director) {
                var me = this;

                var si= new CAAT.Foundation.SpriteImage().initialize(director.getImage('pet'),1,3);
                this.eventYehaaActor = new CAAT.Actor().
                    setBackgroundImage(si).
                    setSpriteIndex(2).
                    enableEvents(false).
                    setVisible(false).
                    rescale().
                    setId("yehaa");
                this.rootActor.addChild(this.eventYehaaActor);

                this.gameModel.addListener(function (event, data) {
                    if (event === 'yehaa') {
                        me.showYehaa();
                        me.director.audioPlay('snd_yehaa');
                    }
                });

                this.eventYehaaActor.setLocation( 20 + 1.2*this.eventYehaaActor.width, H-100-this.eventYehaaActor.height );

            },

            showYehaa:function () {
                this.showShake(this.eventYehaaActor, 600, 4, 1, 1.2);
            },

            createChronoActor:function (director) {
                var chrono = new iBasket.ChronoActor(this.font, director.getImage("bgchrono"), this.gameModel).
                    enableEvents(false).
                    setLocation(400, 10).
                    setId("chrono");
                this.rootActor.addChild(chrono);
                this.chronoActor= chrono;

                this.gameModel.addListener(chrono.contextEvent.bind(chrono));
            }
        }
    }
});

CAAT.Module({
    defines : "iBasket.BallContainer",
    depends :[ "CAAT.Foundation.ActorContainer"],
    extendsClass:"CAAT.Foundation.ActorContainer",
    extendsWith : {

        __init : function(director, iBasketWorld, worldBox2D) {
            this.__super();
            this.setId(1001);
            this.worldBox2D= worldBox2D;
            this.initialize(director,iBasketWorld);
            this.mouseDown= this.mouseMove;
            this.mouseDrag= this.mouseMove;
            this.__p= new CAAT.Math.Point();
            return this;
        },

        director:   null,
        worldBox2D: null,

        targetActor:null,   // target on screen.

        refActor:   null,
        ref_x:      0,
        ref_y:      0,

        trail:      [],

        shadowImage : null,

        playEnabled : true, // puedo dibujar el trail y jugar ??

        __p : null, // spare point for calculateVelocity

        initialize : function(director, gameModel) {

            this.shadowImage= director.getImage("sombra");

            var ims= director.getValueForKey("IMS");

            this.fillStyle='#00f';

            this.gameModel= gameModel;
            this.director= director;

            var refActorImage= director.getImage('ball_ref');
            var refActorScale= 2*(iBasket.Prefs.GameBasketBall.radius * CAAT.PMR);
            this.refActor1= new CAAT.Foundation.Actor().
                setBackgroundImage( refActorImage ).
                setSize( refActorScale, refActorScale).
                setPositionAnchor(.5,.5).
                enableEvents(false).
                setImageTransformation(CAAT.Foundation.SpriteImage.TR_FIXED_TO_SIZE);
            this.refActor2 = new CAAT.Foundation.Actor().
                setBackgroundImage(director.getImage('ray2')).
                setPositionAnchor(.5, .5).
                enableEvents(false).
                setSize( 2*refActorScale, 2*refActorScale).
                setImageTransformation(CAAT.Foundation.SpriteImage.TR_FIXED_TO_SIZE).
                addBehavior(new CAAT.Behavior.RotateBehavior().
                setValues(0, 2 * Math.PI).
                setCycle(true).
                setDelayTime(0, 15000)).
                addBehavior(
                new CAAT.Behavior.ScaleBehavior().
                    setValues(1, 1.3, 1, 1.3).
                    setCycle(true).
                    setPingPong(true).
                    setDelayTime(0, 5000)
            )
            ;


            this.refActor= new CAAT.Foundation.ActorContainer().
                enableEvents(false).
                setVisible(false).
                addChild(this.refActor2).
                addChild(this.refActor1);

            this.targetActor= new CAAT.Foundation.Actor().
                setBackgroundImage( director.getImage('target') ).
                addBehavior(
                    new CAAT.Behavior.ScaleBehavior().
                            setFrameTime( 0, 1000 ).
                            setValues( .8,1.2, .8,1.2 ).
                            setPingPong().
                            setCycle( true )
                ).
                enableEvents( false).
                setPositionAnchor(.5,.5).
                setVisible(false).
                rescale();

            this.targetAnim= new CAAT.Foundation.Actor().
                setBackgroundImage( director.getImage("target_anim" )).
                addBehavior(
                    new CAAT.Behavior.ScaleBehavior().
                        setValues(4,0,4,0).
                        setDelayTime(0,600).
                        setId(100).
                        addListener( {
                            behaviorExpired : function(behavior,time,actor) {
                                actor.setVisible(false);
                            }
                        }).
                        setInterpolator( new CAAT.Behavior.Interpolator().createExponentialOutInterpolator( 3 ) ) ).
                enableEvents(false).
                setPositionAnchor(.5,.5).
                setVisible(false).
                setImageTransformation( CAAT.Foundation.SpriteImage.TR_FIXED_TO_SIZE).
                rescale();

            this.addChild( this.targetAnim );
            this.addChild( this.targetActor );
            this.addChild( this.refActor );

            this.trail= [];
            for( var i=0; i<20; i++ ) {
                this.trail.push( { x:0, y:0 } );
            }


            this.ballContainer= new CAAT.Foundation.ActorContainer().
                    setBounds(0,0,W,H).
                    enableEvents(false);

            var me= this;
            this.ballContainer.paint = function( director, time ) {
                var ctx= director.ctx;
                var hh= H-iBasket.Prefs.GROUND_POS - me.shadowImage.getHeight()/2;

                iBasket.BallContainer.superclass.paint.call( this, director, time );
                for( var i=0; i<this.getNumChildren(); i++ ) {
                    var ball= this.getChildAt(i);
                    me.shadowImage.paintAtRect( director, time, ball.x, hh,
                        ball.width, 2*me.shadowImage.getHeight());
                }
            };

            this.addChild(this.ballContainer);
        },

        contextEvent : function() {

        },

        reset : function() {
            for( var i=0; i< this.ballContainer.getNumChildren(); i++ ) {
                this.ballContainer.getChildAt(i).setOutOfFrameTime();
            }
            this.clearTrail();
            this.canPlay(false);
        },

        canPlay : function( bool ) {
            this.playEnabled= bool;
            this.targetActor.setVisible( bool );
            this.refActor.setVisible( bool );
            this.enableEvents(bool);
        },

        setBounds : function( x,y,w,h ) {
            iBasket.BallContainer.superclass.setBounds.call( this, x,y,w,h );
            this.ballContainer.setBounds(0,0,w,h);
//            this.starContainer.setBounds(0,0,w,h);
            return this;
        },

        /**
         *
         * @param data {ballType{number}, ballPosition{number}}
         */
        newBall : function(data) {

            /**
             * posicion linea de 6,25 en pixels de la imagen del fondo.
             * @type {Number}
             */
            var de3= iBasket.Prefs.CANCHA.TRIPLE_POS_PX;
            var minBolaPos= iBasket.Prefs.CANCHA.MIN_BOLA_POS;

            if ( data.ballPosition===2 ) {
                this.ref_x= minBolaPos+ (de3-minBolaPos)*Math.random();
            } else {
                this.ref_x= de3+ (WORLD_RIGHT_BOUNDS-de3-20)*Math.random();
            }

            this.ref_y= iBasket.Prefs.CANCHA.POS_ARO + (
                    iBasket.Prefs.CANCHA.POS_SUELO-
                    iBasket.Prefs.CANCHA.POS_ARO-
                    iBasket.Prefs.CANCHA.MIN_DISTANCIA_TIRO_SUELO )*Math.random();

            this.refActor.setLocation( this.ref_x, this.ref_y );

            this.showTarget();

            this.targetActor.setVisible(false);
        },

        showTarget : function() {
            this.targetAnim.setLocation( this.refActor.x, this.refActor.y).setVisible(true);
            this.targetAnim.getBehavior(100).
                setDelayTime(0,600);
        },

        mouseUp : function(ev) {

            if (!this.gameModel.canCreateBall() ) {
                return;
            }

            var mx= ev.point.x + iBasket.Prefs.FINGER_OFFSET_X;
            var my= ev.point.y + iBasket.Prefs.FINGER_OFFSET_Y;

            var child= this.gameModel.createPlayingBall(
                    this.director,
                    this.worldBox2D,
                    this.ref_x, this.ref_y,
                    mx,my,
                    this.calculateVelocity( mx- this.ref_x,my- this.ref_y ),
                    true).
                setDiscardable(true).
                setFrameTime( ev.source.time, iBasket.Prefs.BALL_LIFETIME );

            var me= this;

            this.ballContainer.addChild( child );

            //this.calculateTrail(mx, my);
            this.clearTrail();
            this.targetActor.setVisible(false);

        },
        mouseMove : function(ev) {
            this.targetActor.setVisible(true);
            var x= ev.point.x + iBasket.Prefs.FINGER_OFFSET_X;
            var y= ev.point.y + iBasket.Prefs.FINGER_OFFSET_Y;
            this.calculateTrail(x,y);
            this.targetActor.setPosition(x,y);
        },
        clearTrail : function() {
            this.trail.length =0;
        },
        calculateTrail : function(mx,my) {

            this.trail.length =0;
            var v= this.calculateVelocity(mx- this.ref_x,my- this.ref_y);
            var rx= this.ref_x/CAAT.PMR;
            var ry= this.ref_y/CAAT.PMR;

            var prevy= ry, prevx= rx;
            
            var peakFound = false ;
            var peakT = -v.y / iBasket.Prefs.GRAVITY ; // Derive equation for "y", then equal derivative to 0 and extract "t"

            for( var i=0; i<20 && !peakFound; i++ ) {

                var t= i/20;

                if( t > peakT )
                {
                    t = peakT ;
                    peakFound = true;
                }

                var x = (v.x * t) + rx;
	            var y = (0.5 * iBasket.Prefs.GRAVITY * t * t) + (v.y * t) + ry;

                //this.trail[i].x=x*CAAT.PMR;
                //this.trail[i].y=y*CAAT.PMR;
                this.trail.push(x*CAAT.PMR, y*CAAT.PMR);

                prevy= y;
                prevx= x;
            }
        },

        /**
         * x,y est‡n en pixel.
         * @param x
         * @param y
         */
        calculateVelocity : function(x,y) {

            var xx= x/CAAT.PMR;
            var yy= Math.abs(y)/CAAT.PMR;
            var vy= Math.sqrt( yy*2*iBasket.Prefs.GRAVITY);
            var vx= xx/(vy/iBasket.Prefs.GRAVITY);

            this.__p.x= vx;
            this.__p.y= -vy;

            return this.__p;
        },

        paint : function( director, time ) {
            if ( this.playEnabled && this.trail.length > 2) {
                var ctx= director.ctx;
                ctx.beginPath();
                if (ctx.addLineStrip) {
                    ctx.addLineStrip(this.trail);
                } 
                else {
                    ctx.moveTo(this.trail[0], this.trail[1]);
                    for( var i=2; i<this.trail.length; i+=2 ) {
                        ctx.lineTo(this.trail[i], this.trail[i+1]);
                    }
                }
                ctx.strokeStyle='white';
                ctx.lineWidth=2/100*CAAT.PMR;
                ctx.stroke();
            }
        }

    }
});

CAAT.Module({
    defines : "iBasket.NetDrawer",
    depends :[ "CAAT.Foundation.ActorContainer"],
    extendsClass:"CAAT.Foundation.ActorContainer",
    extendsWith : {

        __init : function(box2dworld) {
            this.__super();
            this.world= box2dworld;
            this.enableEvents(false);
            return this;
        },

        world: null,
        lines: [],
        paint: function(director,time) {

            if ( !iBasket.Prefs.NetInfo.DRAW_NET ) {
                return this;
            }

            var ctx= director.ctx;

            ctx.strokeStyle= iBasket.Prefs.NetInfo.NET_LINE_COLOR;
            ctx.lineWidth=iBasket.Prefs.NetInfo.NET_LINE_WIDTH;
            ctx.beginPath();
            //// draw distancejoints.
            if (ctx.addLines) {
                                 //// draw distancejoints.
                this.lines.length = 0;
                for (var j = this.world.GetJointList(); j; j = j.GetNext()) {
                    var ud= j.GetUserData();
                    if ( !ud || !ud.nodraw ) {
                        var p1 = j.GetBodyA().GetPosition() ;
                        var p2 = j.GetBodyB().GetPosition() ;
                        this.lines.push(p1.x*CAAT.PMR, p1.y*CAAT.PMR, p2.x*CAAT.PMR, p2.y*CAAT.PMR);
                    }
                }
                ctx.addLines(this.lines);
            }
            else {
                for (var j = this.world.GetJointList(); j; j = j.GetNext()) {
                    var ud= j.GetUserData();
                    if ( !ud || !ud.nodraw ) {
                        var p1 = j.GetBodyA().GetPosition() ;
                        var p2 = j.GetBodyB().GetPosition() ;
                        ctx.moveTo(p1.x*CAAT.PMR, p1.y*CAAT.PMR);
                        ctx.lineTo(p2.x*CAAT.PMR, p2.y*CAAT.PMR);
                    }
                }
            }
            ctx.stroke();
        }
    }
});

CAAT.Module({
    defines : "iBasket.ScoreActor",
    depends :[ "CAAT.Foundation.UI.TextActor", "CAAT.Foundation.ActorContainer"],
    extendsClass:"CAAT.Foundation.ActorContainer",
    extendsWith : {

        __init : function(font, img){
            this.__super();


            this.scoreActor= new CAAT.Foundation.UI.TextActor().
                setAlign("center").
                setTextBaseline("middle").
                setFont(font).
                setText("000000").
                enableEvents(false);

            this.enableEvents(false).
                setBackgroundImage(img).
                rescale().
                addChild(this.scoreActor);

            this.scoreActor.centerAt( this.width/2, this.height/2 );

            this.interpolator= new CAAT.Behavior.Interpolator().createExponentialInOutInterpolator(2,false);
            return this;
        },

        numDigits:      6,

        scoreActor: null,

        incrementScore: 0,
        maxScore:       0,
        minScore:       0,
        currentScore:   0,

        startTime:      0,
        interpolator:   null,
        scoreDuration:  2000,

        reset : function() {
            this.currentScore= 0;
            this.maxScore= 0;
            this.minScore= 0;
            this.currentScore=0;
            this.startTime=0;
            this.setScore();
        },
        initialize : function() {
            return this;
        },
        gameEvent : function(event, data) {
            if ( event==='score' ) {
                this.maxScore= data;
                this.minScore= this.currentScore;
                this.incrementScore= this.maxScore- this.minScore;
                this.startTime= this.time;
            } else if ( event==='status' && data===iBasket.GameModel.STATUS.ABORTGAME ) {
                this.reset();
            }
        },
        setScore: function() {
            this.currentScore>>=0;
            var str= ''+this.currentScore;
            while( str.length<6 ) {
                str='0'+str;
            }
            this.scoreActor.setText(str);
        },
        animate : function(director, time) {
            if ( time>= this.startTime && time<this.startTime+this.scoreDuration ) {
                this.currentScore=
                        this.minScore +
                            this.incrementScore *
                            this.interpolator.getPosition( (time-this.startTime)/this.scoreDuration ).y;
                this.setScore(director);

            } else {
                if ( this.currentScore!=this.maxScore ) {
                    this.currentScore= this.maxScore;
                    this.setScore(director);
                }
            }

            return iBasket.ScoreActor.superclass.animate.call(this,director,time);
        }
    }
});

CAAT.Module({
    defines : "iBasket.LeapController",
    depends :[ "iBasket.BallContainer"],
    extendsWith : {
        __init : function(director) {

            var LEAP_MILLIMETERS_EACH_HORIZONTAL_WAY = 200;
            var BASKETBALL_COURT_HALF_WIDTH_IN_LOGIC_UNITS = W * 365 / 900;
            var LEAP_WIDTH_CONVERSION_FACTOR = BASKETBALL_COURT_HALF_WIDTH_IN_LOGIC_UNITS / LEAP_MILLIMETERS_EACH_HORIZONTAL_WAY;

            var LEAP_MILLIMETER_VERTICAL = 400;
            var BASKETBALL_COURT_HEIGHT_IN_LOGIC_UNITS = H / 2;
            var LEAP_HEIGHT_CONVERSION_FACTOR = BASKETBALL_COURT_HEIGHT_IN_LOGIC_UNITS / LEAP_MILLIMETER_VERTICAL;
 
            var MILLIMITERS_TO_CONSIDER_A_THROW = 700;
            var FORBID_THOW_WAIT_TIME = 500;
            var TIP_POSITION_BUFFER_SIZE = 20;

            var ws = null;

            var IMS = director.getValueForKey("IMS");
            var tipPositionBuffer = [];
            var canThrow = true;
            var eventObject = new CAAT.Event.MouseEvent();

            var ballContainer = director.getValueForKey("ballContainer");

            function allowToThrowAgain()
            {
                canThrow = true;
            }

            // Support both the WebSocket and MozWebSocket objects
            if ((typeof(WebSocket) == 'undefined') &&
                (typeof(MozWebSocket) != 'undefined')) {
                WebSocket = MozWebSocket;
            }

            //Create and open the socket
            ws = new WebSocket("ws://localhost:6437/");

            // On successful connection
            ws.onopen = function(event) {
                connected = true;
                console.log("WebSocket connection open!");
            };
          
            // On message received
            ws.onmessage = function(event) {
                leapData = JSON.parse(event.data);
                if (leapData && leapData.pointables && leapData.pointables.length > 0)
                {
                    var pointable = leapData.pointables[0];

                    if (canThrow && (pointable.tipVelocity[0] < -MILLIMITERS_TO_CONSIDER_A_THROW))
                    {
                        console.log("THROW: " + pointable.tipVelocity[0]);

                        canThrow = false;
                        setTimeout(allowToThrowAgain, FORBID_THOW_WAIT_TIME);
                        if (tipPositionBuffer.length > 0)
                        {
                            eventObject.point.x = tipPositionBuffer[0][0];
                            eventObject.point.y = tipPositionBuffer[0][1];
                            ballContainer.mouseUp(eventObject);
                        }
                    }
                    else
                    {
                        eventObject.point.x = pointable.tipPosition[0] * LEAP_WIDTH_CONVERSION_FACTOR + BASKETBALL_COURT_HALF_WIDTH_IN_LOGIC_UNITS;
                        eventObject.point.y = -pointable.tipPosition[1] * LEAP_HEIGHT_CONVERSION_FACTOR + BASKETBALL_COURT_HEIGHT_IN_LOGIC_UNITS;
                        ballContainer.mouseMove(eventObject);
                        if (tipPositionBuffer.length >= TIP_POSITION_BUFFER_SIZE)
                        {
                          tipPositionBuffer.shift();
                        }
                        tipPositionBuffer.push([eventObject.point.x, eventObject.point.y]);
                    }
                }
            };
          
            // On socket close
            ws.onclose = function(event) {
                ws = null;
                console.log("WebSocket connection closed!");
            };
          
            //On socket error
            ws.onerror = function(event) {
                alert("Error received!");
            };
        }
    }
});


CAAT.Module({
    defines : "iBasket.MultiplierActor",
    depends :[ "CAAT.Foundation.Actor"],
    extendsClass : "CAAT.Foundation.Actor",

    extendsWith : {

        multiplier: 0,
        timer:      null,
        scene:      null,

        initialize : function( scene ) {

            this.scene= scene;
            return this;
        },
        hideMultiplier : function() {
            this.multiplier=0;
            this.setVisible(false);
        },
        b1 : function() {
            this.setVisible(true);
            var cb= new CAAT.ContainerBehavior().
                    setFrameTime(this.time,1000).
                    setCycle(true);

            this.addBehavior(cb);
        },
        b2 : function() {

            if ( this.timer ) {
                this.timer.cancel();
                this.timer= null;
            }

            var me= this;
            this.emptyBehaviorList();
            var ab= new CAAT.AlphaBehavior().
                    setFrameTime(this.time,300).
                    setValues( this.alpha, 0 ).
                    addListener( {
                        behaviorExpired : function(behavior, time, actor) {
                            me.hideMultiplier();
                        },
                        behaviorApplied : function(actor,time,normalizedTime,value) {}
                    });
            this.addBehavior(ab);
        },
        reset : function() {
            this.emptyBehaviorList();
            this.setVisible(false);
        },
        contextEvent : function( event, data ) {
            var me= this;

            if ( event==='multiplier' ) {

                if ( data==='none' ) {
                    if ( this.timer ) {
                        this.timer.cancel();
                        this.timer= null;
                    }
                    this.emptyBehaviorList();
                    this.b2();
                } else if ( data==='2' || data==='3' ) {

                    this.setVisible(true);
                    this.alpha= 1;

                    if ( this.timer ) {
                        this.timer.reset(this.scene.time);
                    } else {
                        this.timer= this.scene.createTimer(
                            this.scene.time,
                            iBasket.GameModel.MULTIPLIER_TIME,
                            function( sceneTime, timertaskTime, timertask ) {
                                me.b2();
                            });
                    }

                    this.setVisible(true);
                    this.setSpriteIndex(data==='2' ? 0 : 1);
                    this.emptyBehaviorList();
                    this.addBehavior(
                        new CAAT.ScaleBehavior().
                            setFrameTime(this.time,1000).
                            setValues(.9, 1.1, .9, 1.1 ).
                            setPingPong().
                            setCycle(true));

                    this.b1();

                } else {
                    this.b2();
                }
            }
        }
    }
});

CAAT.Module({
    defines : "iBasket.AchievementActor",
    depends : [
        "CAAT.Foundation.ActorContainer"
    ],
    extendsClass : "CAAT.Foundation.ActorContainer",
    extendsWith : {
        __init : function(director,font) {

            this.__super();

            var ims= CAAT.currentDirector.getValueForKey("IMS");
            var sc= CAAT.currentDirector.getValueForKey("WORLD_SCREEN_SCALE");

            this.setBackgroundImage("achievements").
                enableEvents(false).
                setVisible(false).
                setGlobalAlpha(true).
                setScale(sc/ims,sc/ims);

            this.centerAt( director.width-this.width/2-20, director.height/2 );

            this.text= new CAAT.Foundation.UI.TextActor().
                setFont(font).
                setTextAlign("center").
                setTextBaseline("middle").
                setText("").
                setScale(.75*sc,.75*sc).
                enableEvents(false).
                setId(1234);

            this.addChild(this.text);

            this.cb= new CAAT.Behavior.ContainerBehavior().
                addBehavior(
                    new CAAT.Behavior.AlphaBehavior().
                        setValues(0,1).
                        setFrameTime(0,500)).
                addBehavior(
                    new CAAT.Behavior.AlphaBehavior().
                        setValues(1,0).
                        setFrameTime(2500,500)).
                addListener({
                    behaviorExpired : function(bahavior, time, actor) {
                        actor.setVisible(false);
                    }
                });

            this.addBehavior(this.cb);

            director.getValueForKey("GameModel").achievementsManager.addListener( this.achievementUnlocked.bind(this) );
        },

        cb: null,
        text : null,

        achievementUnlocked : function( achievement ) {
            var ims= CAAT.currentDirector.getValueForKey("IMS");
            var sc= CAAT.currentDirector.getValueForKey("WORLD_SCREEN_SCALE");
            this.setVisible(true);
            this.text.setText(achievement.description.toUpperCase());

            this.text.centerAt( ims*(208 + 440/2), ims*(515 + 67/2) );
            this.cb.setDelayTime(0,3000);
        }
    }
});

CAAT.Module({
    defines : "iBasket.ChronoActor",
    depends :[ "CAAT.Foundation.UI.TextActor", "CAAT.Foundation.ActorContainer"],
    extendsClass : "CAAT.Foundation.ActorContainer",
    extendsWith : {

        __init : function(font, img) {
            this.__super();

            this.chrono= new CAAT.Foundation.UI.TextActor().
                setAlign("center").
                setTextBaseline("middle").
                setFont(font).
                setText("00:00").
                enableEvents(false);

            this.enableEvents(false).
                setBackgroundImage(img).
                rescale().
                addChild(this.chrono);

            this.chrono.centerAt( this.width/2, this.height/2 );

            return this;
        },

        gameStartTime:  0,
        timer :         null,
        scene:          null,
        chrono:           null,

        reset : function() {
            this.gameStartTime= 0;
        },

        contextEvent : function( event, data ) {

            if ( event==='start_time' ) {
                this.gameStartTime= data.gameStart;
            } else if (event==='status' && data===iBasket.GameModel.STATUS.ABORTGAME ) {
                this.gameStartTime= 0;
            } else if (event==='chrono_pip') {
                CAAT.currentDirector.audioPlay("snd_pip");
                this.chrono.emptyBehaviorList();
                this.chrono.addBehavior(
                    new CAAT.Behavior.ScaleBehavior().
                        setValues( 1,1.5, 1,1.5).
                        setDelayTime(0, 500).
                        setPingPong()
                );
            }
        },

        animate : function( director, time ) {

            var gameDuration= director.getValueForKey("GameModel").getGameDuration();

            var t;
            if ( this.gameStartTime!=0 )    {
                t= gameDuration - (time - this.gameStartTime);
            } else {
                t= 0;
            }

            if (t<0)    {
                t=0;
            }

            var str= "00:00";
            if ( t )    {

                var millis=     ((t%1000)/10)>>0;
                var seconds=    (t/1000)>>0;

                if ( seconds<10 )   {
                    str="0"+seconds;
                } else {
                    str= (seconds)>>0;
                }

                str+=":";
                str+= ( (millis/10)>>0 ) + "" + ( millis%10 );
            }

            this.chrono.setText(str);

            return iBasket.ChronoActor.superclass.animate.call(this,director,time);
        }
    }
});