var iBackend = iBackend || {};



(function() {

    function setupPurchases(director, f) {

        if (!navigator.isCocoonJS) {
            f();
            return;
        }

        if (CocoonJS.Store.nativeExtensionObjectAvailable && CocoonJS.Store.canPurchase()) {

            CocoonJS.Store.requestInitialization( {sandbox: false, managed:true} );

            CocoonJS.Store.start();

            var products = CocoonJS.Store.getProducts();
            director.setValueForKey("iBasket.Products", products);

            var purchases = CocoonJS.Store.getPurchases();
            if (purchases && purchases.length > 0) {
                iBasket.Prefs.ADS_ENABLED= false;
            }
        }

        f();
    }

    function setupAskRate(director) {

        var ratePolicy= new iBasket.Policy(
            iBasket.Prefs.RATING_POLICY.TIME,
            iBasket.Prefs.RATING_POLICY.COUNTER,
            iBasket.Prefs.RATING_POLICY.OPERATOR,
            null,
            function() {

                if ( CAAT.getCurrentScene().getId()==="iBasket.MenuScene") {
                    iBasket.Util.tryShowRate();
                }
            }
        );
        director.setValueForKey("RatingPolicy", ratePolicy);

        if (!navigator.isCocoonJS || CAAT.Module.Storage.LocalStorage.load("iBasket.Rated")) {
            ratePolicy.disable();
        }
    }

    function setupAds(director) {

        var interstitialPolicy= new iBasket.Policy(
                    iBasket.Prefs.INTERSTITIAL_POLICY.TIME,
                    iBasket.Prefs.INTERSTITIAL_POLICY.COUNTER,
                    iBasket.Prefs.INTERSTITIAL_POLICY.OPERATOR,
                    function() {
                        console.log("Called interstitialPolicyMet reset.");
                        iBasket.INTERSTITIAL= false;
                    },
                    function() {
                        console.log("Called interstitialPolicyMet Callback.");
                        iBasket.INTERSTITIAL= true;
                    }
                );

        director.setValueForKey("InterstitialPolicy",interstitialPolicy);

        if ( navigator.isCocoonJS && iBasket.Prefs.ADS_ENABLED ) {

            CocoonJS.Ad.preloadBanner();
            CocoonJS.Ad.preloadFullScreen();
            
            CocoonJS.Ad.setBannerLayout( CocoonJS.Ad.BannerLayout.BOTTOM_CENTER );

            CocoonJS.Ad.onFullScreenShown.addEventListener( function() {
                CAAT.currentDirector.endSound();
                CAAT.endLoop();
            });

            CocoonJS.Ad.onFullScreenHidden.addEventListener( function() {
                CAAT.loop(60);
                director.musicPlay("music");
                director.getValueForKey("InterstitialPolicy").reset();
            });

            director.setValueForKey("iBasket.REMOVE_ADS", function() {
                iBasket.Prefs.ADS_ENABLED= false;
                CocoonJS.Ad.hideBanner();
                director.getValueForKey("InterstitialPolicy").disable();
            });
        } else {
            interstitialPolicy.disable();
            console.log("no need to enable ads");
        }
    }

    function createScenes(director) {


        initializeSocial();

        var font= createFontFromData(
            director.getImage("font"),
            ibasketPrecachedData.font,
            director.getValueForKey("IMS") );

        new iBasket.iBasketMenuScene().initialize(director, font);
        new iBasket.World().initialize(director, font);
        new iBasket.Result().initialize(director, font);
        new iBasket.Pause().initialize(director, font);

    }

    function initializeSocial() {
        var sgm= CocoonJS.SocialGaming.SocialGamingManager;

        sgm.registerSocialGamingService( "localStorage", {
            service : CocoonJS.SocialGaming.LocalStorage,
            userData : null
        });
        CocoonJS.SocialGaming.LocalStorage.requestInitialization({
            score :         "iBasket.Score",
            achievements :  "iBasket.Achievements"
        });

        var srvFB= CocoonJS.SocialGaming.Facebook;
        srvFB._ibasket= {};
        sgm.registerSocialGamingService( "fb", {
            service     : srvFB,
            userData    : {
                image : 'menu_button_fb_gc',
                frames: [0,1,2]
            }
        }).
        on("requestLoginSucceed", function(userInfo) {
            CocoonJS.SocialGaming.Facebook._ibasket.userInfo= userInfo;
            CocoonJS.SocialGaming.Facebook.requestAllAchievements();
            CocoonJS.SocialGaming.Facebook.IN= true;

            if (!srvFB.hasPublishPermission()) {
                var messageBoxConfirmed = function() {
                    srvFB.requestAdditionalPermissions('publish', 'publish_actions', function(response) {
                        CocoonJS.App.onMessageBoxConfirmed.removeEventListener(messageBoxConfirmed);
                        CocoonJS.App.onMessageBoxDenied.removeEventListener(messageBoxDenied);
                        if (response.error) {
                            alert("Sending scores and achievements to Facebook will be disabled for the current Facebook session.");
                        }
                    });
                };
                CocoonJS.App.onMessageBoxConfirmed.addEventListener(messageBoxConfirmed);

                var messageBoxDenied = function() {
                    CocoonJS.App.onMessageBoxConfirmed.removeEventListener(messageBoxConfirmed);
                    CocoonJS.App.onMessageBoxDenied.removeEventListener(messageBoxDenied);
                    alert("Sending scores and achievements will be disabled for the current Facebook session.");
                };
                CocoonJS.App.onMessageBoxDenied.addEventListener(messageBoxDenied);

                CocoonJS.App.showMessageBox("Facebook permissions", "Publish permissions are needed to submit scores and achievements.", "Grant permissions", "No, thanks");
            }
        }).
        on("requestLoginFailed",function () {
            console.log("Login to Facebook failed !");
        }).
        on("logout",function() {
            CocoonJS.SocialGaming.Facebook._ibasket= {};
        }).
        on("requestAllAchievementsSucceed", function(achievementsInfo) {
            // achievementsInfo: Array<CocoonJS.SocialGaming.AchievementInfo>
            CocoonJS.SocialGaming.Facebook._ibasket.allAchievementsInfo= achievementsInfo;
        }).
        on("requestInitializationSucceed", function() {
            if (!navigator.isCocoonJS ) {
                CocoonJS.SocialGaming.Facebook.requestLogin();
            }
        }).
        on("requestInitializationFailed", function() {
            console.log("initialization failed.");
        }).
        setAbstractToSocialGamingAchievementMap(iBasket.Prefs.FACEBOOK_PARAMS.FACEBOOK_ACHIEVEMENTS_MAP);

        try
        {
            srvFB.requestInitialization(iBasket.Prefs.FACEBOOK_PARAMS);
        }
        catch(ex)
        {
            console.error("Exception initializing Facebook: " + ex);
        }

        var srvGC= CocoonJS.SocialGaming.GameCenter;
        sgm.registerSocialGamingService("gc", {
            service : srvGC,
            userData    : {
                image : 'menu_button_fb_gc',
                frames: [3,4,5]
            }
        } ).
        setAbstractToSocialGamingAchievementMap(iBasket.Prefs.GAME_CENTER_ACHIEVEMENTS_MAP).
        on("requestInitializationSucceed", function() {
            console.log("GC initialization.");
            srvGC.requestLogin();
        }).
        on("requestLoginSucceed", function(userInfo) {
            console.log("GC login: "+JSON.stringify(userInfo));
        });

        try
        {
            srvGC.requestInitialization();
        }
        catch (ex)
        {
            console.error("Exception initializing Game Center: " + ex);
        }

    }

    function __load(c, timerID) {

            CAAT.ModuleManager.
                //debug(true).
                setModulePath("iBasket", "static/js").

                setModulePath("CAAT.Module.Preloader",    "CAAT/Modules/Image/Preloader").

                setModulePath("CAAT.Module", "CAAT/Modules").
                // get modules, and solve their dependencies.
                bring(
                [
                    "CAAT.Foundation.Director",
                    "CAAT.Module.Preloader.Preloader",
                    "CAAT.Foundation.Box2D.B2DPolygonBody",
                    "CAAT.Foundation.Box2D.B2DCircularBody",
                    "CAAT.Foundation.UI.Layout.GridLayout",
                    "CAAT.Foundation.UI.Layout.BoxLayout",
                    "CAAT.Foundation.UI.TextActor",
                    "CAAT.Module.Storage.LocalStorage",
                    "iBasket.LoadingLayer",
                    "iBasket.iBasketUtil",
                    "iBasket.iBasketMenuScene",
                    "iBasket.iBasketScene",
                    "iBasket.iBasketGameModel",
                    "iBasket.iBasketMenuScene",
                    "iBasket.iBasketResultScene",
                    "iBasket.iBasketPauseScene",
                    "iBasket.policy"
                ]
            ).onReady( function() {
                start(c, timerID);
            });
    }

    function start(c, timerID) {


        // If the app is sent to background, we stop the audio and loop and restore them when we are activated again.
        CocoonJS.App.onSuspended.addEventListener( function() {
            CAAT.endLoop();
        });
        CocoonJS.App.onActivated.addEventListener( function() {
            CAAT.loop(60);
        });

        /*
        make sure you click more than drag ;)
         */
        if (navigator.isCocoonJS) {
            CAAT.DRAG_THRESHOLD_X=      15;
            CAAT.DRAG_THRESHOLD_Y=      15;
        }

        var refTime= new Date().getTime();

        CAAT.CACHE_SCENE_ON_CHANGE= false;

        var director = new CAAT.Foundation.Director().
            initialize(c.width, c.height, c).
            setClear(false);

        director.setValueForKey("W", 2048);
        director.setValueForKey("H", 1536);
        director.setValueForKey("WORLD_SCREEN_SCALE", Math.min( director.width/2048, director.height/1536 ));
        director.setSoundEffectsEnabled( CAAT.Module.Storage.LocalStorage.load("iBasket.Sound", true ) );
        director.setMusicEnabled( CAAT.Module.Storage.LocalStorage.load("iBasket.Music", true ) );

        director.setValueForKey("IMS", ( c.width>2000 ) ? 1 :.5 );

        CAAT.Foundation.Actor.prototype.rescale= function() {
            var ims= CAAT.currentDirector.getValueForKey("IMS");
            this.width/=ims;
            this.height/=ims;
            this.setImageTransformation( CAAT.Foundation.SpriteImage.TR_FIXED_TO_SIZE );
            return this;
        };
        CAAT.Foundation.ActorContainer.prototype.rescale= function() {
            CAAT.Foundation.ActorContainer.superclass.rescale.call(this);
            for( var i=0; i<this.getNumChildren(); i++ ) {
                this.getChildAt(i).rescale();
            }
            return this;
        };
        CAAT.Foundation.Actor.prototype.rescaleToScreen= function() {
            var ims= CAAT.currentDirector.getValueForKey("IMS");
            var wss= CAAT.currentDirector.getValueForKey("WORLD_SCREEN_SCALE");
            var w= this.width*wss/ims;
            var h= this.height*wss/ims;
            this.setSize(w,h);
            this.setImageTransformation( CAAT.Foundation.SpriteImage.TR_FIXED_TO_SIZE );
            return this;
        };
        CAAT.Foundation.ActorContainer.prototype.rescaleToScreen= function() {
            CAAT.Foundation.ActorContainer.superclass.rescaleToScreen.call(this);
            for( var i=0; i<this.getNumChildren(); i++ ) {
                this.getChildAt(i).rescaleToScreen();
            }
            var ims= CAAT.currentDirector.getValueForKey("IMS");
            var wss= CAAT.currentDirector.getValueForKey("WORLD_SCREEN_SCALE");
            var w= this.width*wss/ims;
            var h= this.height*wss/ims;
            this.setSize(w,h);
            this.setImageTransformation( CAAT.Foundation.SpriteImage.TR_FIXED_TO_SIZE );
            return this;
        };

        var is= director.getValueForKey("IMS")===1 ? '' : '2';

        new CAAT.Module.Preloader.Preloader().
            addElement('menu_pack','static/res_ibasket/menu_pack/menu'+is+'.png').
            addElement('game_pack', 'static/res_ibasket/game_pack/game'+is+'.png').
            load(
                function(images) {

                    window.clearInterval(timerID);
                    director.emptyScenes();
                    director.setImagesCache(images);

                    /*createSpriteMap(
                        director,
                        director.getImage("menu_pack"),
                        "static/res_ibasket/menu_pack/menu"+is+".json",
                        1 );
                    createSpriteMap(
                        director,
                        director.getImage("game_pack"),
                        "static/res_ibasket/game_pack/game"+is+".json",
                        1 );*/

                    createSpriteMapFromData(
                        director,
                        director.getImage("menu_pack"),
                        ibasketPrecachedData["menu" + is],
                        1 );
                    createSpriteMapFromData(
                        director,
                        director.getImage("game_pack"),
                        ibasketPrecachedData["game" + is],
                        1 );


                    var prefix= "static/res_ibasket/sound/";

                    director.setAudioFormatExtensions( ["ogg","mp3"] );
                    director.
                        addAudio("snd_airhorn",  prefix+"airhorn.mp3").
                        addAudio("snd_start",    prefix+"start.mp3").
                        addAudio("snd_bounce1",  prefix+"bounce1.mp3").
                        addAudio("snd_bounce2",  prefix+"bounce2.mp3").
                        addAudio("snd_bounce3",  prefix+"bounce3.mp3").
                        addAudio("snd_bounce4",  prefix+"bounce4.mp3").
                        addAudio("snd_bounceb1", prefix+"bounceb1.mp3").
                        addAudio("snd_bounceb2", prefix+"bounceb2.mp3").
                        addAudio("snd_bounceb3", prefix+"bounceb3.mp3").
                        addAudio("snd_bounceb4", prefix+"bounceb4.mp3").
                        addAudio("snd_net",      prefix+"canasta.mp3").
                        addAudio("snd_clean",    prefix+"clean.mp3").
                        addAudio("snd_pip",      prefix+"pip.mp3").
                        addAudio("snd_tablero",  prefix+"tablero.mp3").
                        addAudio("snd_yehaa",    prefix+"yehaa.mp3").
                        addAudio("music",        prefix+"music.mp3");

                    setupPurchases(director, function() {
                        createScenes(director);
                        setupAds(director);
                        setupAskRate(director);

                        refTime= iBasket.Prefs.LOADING_SCREEN_TIME - (new Date().getTime()-refTime);
                        if (refTime<=0 ) {
                            refTime=0;
                        }

                        setTimeout(function() {
                            /**
                             * Change this sentence's parameters to play with different entering-scene
                             * curtains.
                             * just perform a director.setScene(0) to play first director's scene.
                             */
                            director.setScene(0);
                            CAAT.loop(60);
                            director.musicPlay("music").volume= .2;
                        },refTime);
                    });

                },
                function(id) {
                    console.log("loaded : "+id);
                }
        );
    }

    function showSplash() {

        var c= document.createElement( navigator.isCocoonJS ? "screencanvas" : "canvas");
        c.width= window.innerWidth;
        c.height= window.innerHeight;

        if (c.width<100 || c.height<100 ) {
            c.width=800;
            c.height=600;
        }

        document.body.appendChild(c);
        var ctx= c.getContext("2d");

        var img= new Image();

        var draw = function()
        {
            var scale= Math.max(c.width/img.width, c.height/img.height );

            var diffx=0, diffy=0;
            if (c.height<img.height*scale ) {
                diffy= img.height*scale - c.height;
            }
            if (c.width<img.width*scale ) {
                diffx= img.width*scale - c.width;
            }
            ctx.save();
            ctx.setTransform(1,0,0,1,0,0);
            ctx.translate( -diffx/2, -diffy/2 );
            ctx.scale(scale,scale);
            ctx.drawImage(img,0,0 );
            ctx.restore();
        }

        img.onload= function(e) {

            draw();
            var timerID = setInterval(function(){draw();}, 16)
            __load(c, timerID);
        }
        if (c.width<2000 ) {
            img.src='static/res_ibasket/loading2.jpg';
        } else {
            img.src='static/res_ibasket/loading.jpg';
        }
    }

    window.addEventListener(
            'load',
            showSplash,
            false);


//    __load();

})();
