iBasket.Policy= function (timerPolicy, counterPolicy, operator, onResetCallback, callbackMet) {
    this.conditionTimer = false;
    this.conditionCounter = false;
    this.currentCounter = 0;
    this.maxCounter = counterPolicy;
    this.timerPolicyTimerId = null;
    this.timerPolicyMaxTime = timerPolicy;
    this.operator= operator;
    this.disabled= false;

    var me = this;

    this.reset = function () {

        if ( this.disabled ) {
            return this;
        }

        this.stop();

        if (this.timerPolicyMaxTime) {
            this.timerPolicyTimerId = setTimeout(function () {
                    me.__conditionTimerMet();
                },
                this.timerPolicyMaxTime);
        }

        if ( this.onPolicyReset ) {
            this.onPolicyReset();
        }

        return this;
    };

    this.disable = function () {
        this.stop();
        this.maxCounter = 0;
        this.timerPolicyMaxTime = 0;
        this.disabled= true;

        return this;
    }

    this.stop = function () {
        if (this.timerPolicyMaxTime) {
            clearTimeout(this.timerPolicyTimerId);
            this.timerPolicyTimerId = null;
        }

        this.currentCounter = 0;
        this.conditionTimer = false;
        this.conditionCounter = false;

        return this;
    };

    this.incrementCounter = function () {
        if (this.maxCounter) {
            this.currentCounter++;
            if (this.currentCounter >= this.maxCounter) {
                this.__conditionCounterMet();
            }
        }
    };

    this.__conditionTimerMet = function () {
        this.conditionTimer = true;
        this.__notify();
    };

    this.__conditionCounterMet = function () {
        this.conditionCounter = true;
        this.__notify();
    }

    this.__notify = function () {
        if (this.onPolicyMet && this.isPolicyMet() ) {
            this.onPolicyMet();
        }
    };

    this.isPolicyMet= function() {
        if ( this.disabled ) {
            return false;
        }

        if (this.operator === 'and') {
            return (this.conditionTimer && this.conditionCounter);
        } else {
            return (this.conditionTimer || this.conditionCounter);
        }
    }

    this.onPolicyReset = onResetCallback;
    this.onPolicyMet = callbackMet;

    this.reset();

    return this;
}